/*
** Handle menu activations.
** Menu messages have two fields of interest to us:
** which menu tree it refers to, and which item in that menu.
** Since all of our menu items are from the main menu at
** the top of the screen, we only handle that case here (MAINMENU)
** although we use a switch to leave a hook for more complicated
** menu structures we might have in the future.
*/

# include <mandel.h> 			/* This defines MAINMENU */
								/* among other things... */
do_menu(title,item,whand,vw)
int title, item, whand, vw;{
	
	int ret;
	extern struct object *main_addr;
	
	ret = 0;
	switch( title ) {
	case MAINMENU:
	default:
		ret = do_main menu(item,whand,vw);
	}
	menu_tnormal(main_addr,title,1);
	menu_tnormal(main_addr,item,1);
	return( ret );
}